VERSION 8000; ; 8300
* -----------------------------------------------------------------------------
* @filedoc
* @file Punkte_AusExcel.csx
* @brief Punkte aus Excel-Datentabelle importieren
* 
* Dieses Beispielskript importiert Punkte aus einer Excel-Datei. 
* Die Punkte werden in das CSV-Format gespeichert.
*
* -----------------------------------------------------------------------------
* Copyright (C) IB&T
* 
* Gewhrleistung und Nutzung
* 
* Die Nutzung des Skriptes erfolgt stets auf eigene Gefahr. IB&T bernimmt keine
* Gewhr dafr, dass die Nutzung dieses Skriptes zu Ihrem gewnschten Ergebnis
* fhrt. Da CardScripte vorhandene Projektdaten durch Direktzugriff auf die
* jeweiligen Datenbanken auch ohne weitere Sicherheitsabfragen unbemerkt verndern
* oder lschen knnen, erfordert eine Nutzung entsprechende Kenntnisse und groe
* Sorgfalt. IB&T haftet nicht fr eventuell entstehende Datenverluste und
* Folgeschden, die durch die Nutzung von CardScripten entstehen.
*
* -----------------------------------------------------------------------------
* @author JH
* @endfiledoc
* -----------------------------------------------------------------------------
*     8300 14.05.09 JH
* @history
* -----------------------------------------------------------------------------


* Vereinbarungen --------------------------------------------------------------

BILDSCHIRM GRAFIK                 | Meldungen im Arbeitsprotokoll ausgeben


* Implizite Deklarationen -----------------------------------------------------

!TabName = "PunktTab.xls"         | Name der Excel-Datei
!Liste = "Punkte.csv"             | Name der CSV-Datei
!P_BEZ = "Punktliste aus Excel"   | Bezeichnung der CSV-Datei


* Explizite Deklarationen -----------------------------------------------------

SYMBOLE /DBCONNECTION/ DataBase   | Symbol fr Datenbankzugriff
SYMBOLE /DBCOMMAND/ Stmt          | Symbol fr DB-Anweisung 


* Ausfhrungen ----------------------------------------------------------------

* Objekt fr Datenbank
DataBase = Project.GetDataBase()      

* Verbindung mit Excel-Datenbank herstellen
kk = DataBase.ConnectExcel(!TabName; 0)
MELDE "Verbindungsstatus zu Excel (Version #): #"; !!DataBase.GetVersion(); kk
MELDE "(1 = Verbindung ist hergestellt)"

* DB-Anweisung fr die Ausfhrung vorbereiten: Abrufen von Datenstzen aus einer Tabelle
Stmt = DataBase.CreateCommand("SELECT * FROM [Punkte$]")    | ermittelt alle Datenstze aus der Tabelle "Punkte"

  * Weitere Beispiele zum Abrufen von Datenstzen aus einer Tabelle 
    * Stmt = DataBase.CreateCommand("SELECT * FROM Punkte ORDER BY Name") | sortiert nach dem "Namen"
    * Stmt = DataBase.CreateCommand("SELECT * FROM Punkte WHERE Name LIKE 'L%' ORDER BY Name")
    * Stmt = DataBase.CreateCommand("SELECT * FROM Punkte WHERE Z <> 0.0 ORDER BY Z")
    * Stmt = DataBase.CreateCommand("SELECT * FROM Punkte WHERE X > 84300 and X < 84400 ORDER BY Y,X")

* DB-Anweisung SELECT ausfhren
Stmt.Execute()

* Neue Datei fr die auszugebenden Punkte anlegen und ffnen
DAT_NEU 1; NAME = !Liste; BEZ = !P_BEZ; DEZ = "COMMA"

*** Schleife zum Auswerten von 10000 Datenstzen
SCHLEIFE Row = 1; 10000
  WENN Stmt.GetNextRow() == 0 DANN ABBRUCH SCHLEIFE 
  !PName = Stmt.GetStringByName("Name")  | liefert den Text aus der Spalte "Name"
  X = Stmt.GetValueByName("X")           | liefert den Wert aus der Spalte "X"
  Y = Stmt.GetValueByName("Y")           | liefert den Wert aus der Spalte "Y"
  Z = Stmt.GetValueByName("Z")           | liefert den Wert aus der Spalte "Z"
  MELDE "Zeile #####  #"; Row; !PName
  DAT_SCHREIBEN 1; "##################; ########.###; ########.###; ########.###"; !PName; X; Y; Z
ENDE SCHLEIFE 
*** Ende Schleife

* DB-Anweisung auf 'undefiniert' setzen
Stmt = $NULL

* Geffnete Datei schlieen
DAT_ZU 1

* Meldung fr Abfrage generieren
JaList = 0
TEXTGEN !Meldung; "Punkte in Datei # ausgegeben. Anzeigen?"; !Liste
MELDUNG FRAGE; !Meldung; JaList 
WENN JaList == 1 DANN DAT_LISTEN !Liste
