VERSION 8000; ; 9114
* -----------------------------------------------------------------------------
* @filedoc
* @file Punkte_NachExcel.csx
* @brief Punkte in Excel-Datentabelle exportieren
* 
* Dieses Beispielskript exportiert Punkte der CARD/1 Punktdatenbank in eine Excel-Datentabelle
*
* -----------------------------------------------------------------------------
* Copyright (C) IB&T 
* 
* Gewhrleistung und Nutzung
* 
* Die Nutzung des Skriptes erfolgt stets auf eigene Gefahr. IB&T bernimmt keine
* Gewhr dafr, dass die Nutzung dieses Skriptes zu Ihrem gewnschten Ergebnis
* fhrt. Da CardScripte vorhandene Projektdaten durch Direktzugriff auf die
* jeweiligen Datenbanken auch ohne weitere Sicherheitsabfragen unbemerkt verndern
* oder lschen knnen, erfordert eine Nutzung entsprechende Kenntnisse und groe
* Sorgfalt. IB&T haftet nicht fr eventuell entstehende Datenverluste und
* Folgeschden, die durch die Nutzung von CardScripten entstehen.
*
* -----------------------------------------------------------------------------
* @author JH
* @endfiledoc
* -----------------------------------------------------------------------------
*     8300 14.05.09 JH
*     9114 06.04.2021 NR Umstellung auf alphanummerische Kodes
* @history
* -----------------------------------------------------------------------------

  * .......................................................................
  * Eventuell Dialog einbinden, um die Vorbelegungen zu verndern 
  * .......................................................................


* Vereinbarungen --------------------------------------------------------------

BILDSCHIRM GRAFIK                | Meldungen im Arbeitsprotokoll ausgeben
$PRFSTUFE 7

* Implizite Deklarationen -----------------------------------------------------

SYMBOLE * !TabName = "PunktTab.xls"        | Name der Excel-Datentabelle
SYMBOLE * P_Mark = 0                       | Schalter fr: 0 = alle Punkte, 1 = nur markierte Punkte


* Explizite Deklarationen -----------------------------------------------------

SYMBOLE /DBCONNECTION/ DataBase  | Symbol fr Datenbankzugriff
SYMBOLE /DBCOMMAND/ Stmt         | Symbol fr DB-Anweisung 
* Punktobjekte 
SYMBOLE /POINTSYS/ Pointsys      | Symbol fr das System der Punkte
SYMBOLE /POINT/ Pkt              | Symbole fr den Punkt
SYMBOLE /POINTINDEX/ XPoint      | Symbol fr Punktindex
SYMBOLE * !BEZ;!PCODE;!Meldung;kk;!PNAME

* Ausfhrungen ----------------------------------------------------------------

* Objekt fr Datenbank
DataBase = Project.GetDataBase()  

* Objekt fr Punktdatenbank 
Pointsys = Project.GetPointSys()

* vorh. Excel-Datentabelle lschen
DAT_LOESCHEN !TabName

* Verbindung mit Excel-Datenbank herstellen und Datei neu anlegen
kk = DataBase.ConnectExcel(!TabName; 1)
MELDE "Verbindungsstatus zu Excel (Version #): #"; !!DataBase.GetVersion(); kk
MELDE "(1 = Verbindung ist hergestellt)"

* DB-Anweisung fr die Ausfhrung vorbereiten: Anlegen von Datenstzen fr eine Tabelle (Deklaration der Tabellenspalten mit Festlegung der Datentypen) 
Stmt = DataBase.CreateCommand("CREATE TABLE Punkte (Name TEXT, X NUMBER, Y NUMBER, Z NUMBER, Kode TEXT, Bemerkung TEXT)")

* DB-Anweisung CREATE TABLE ausfhren
kk = Stmt.Execute()
MELDE "Status DB-Anweisung CREATE TABLE: #"; kk
MELDE "(1 = Anweisung ist ausgefhrt)"

* DB-Anweisung auf 'undefiniert' setzen
Stmt = $NULL

XPoint = Pointsys.GetPointIndex(2)                      | Filter fr Punkte nach Nummer sortiert
XPoint.SetMarkFilter(P_Mark)                            | setzt einen Filter fr die Punktmarkierung


*** Schleife zum Auswerten von Punkten ber Punktindexfilter
SOLANGE Pkt = XPoint.GetNext()                                   | liest die Punkte ber gesetzte Filter aus
  * Punktobjekt Attribute auslesen 
  !PName = Pkt.GetName()                                         | liefert die Punktnummer
  !BEZ   = Pkt.GetCodeDescription()                              | liefert die Kodebezeichnung
  !PCode = Pkt.GetAlphaCode()                                    | liefert den Punktcode als alphanummerischen Wert
  
  * DB-Anweisung fr die Ausfhrung vorbereiten: Einfgen von Datenstzen in eine Tabelle
  Stmt = DataBase.CreateCommand("INSERT INTO Punkte (Name, X, Y, Z, Kode, Bemerkung) VALUES (:1, :2, :3, :4, :5, :6)")
    Stmt.SetStringByIndex(1; !PName)      | setzt die Punktnummer in die Spalte 1
    Stmt.SetValueByIndex(2; Pkt.GetX())   | setzt den Rechtswert in die Spalte 2 
    Stmt.SetValueByIndex(3; Pkt.GetY())   | setzt den Hochwert in die Spalte 3 
    Stmt.SetValueByIndex(4; Pkt.GetZ())   | setzt die Hhe in die Spalte 4 
    Stmt.SetStringByIndex(5; !PCode)      | setzt den Kode in die Spalte 5 
    Stmt.SetStringByIndex(6; !BEZ)        | setzt die Kodebezeichnung in die Spalte 6
    
  * DB-Anweisung INSERT INTO ausfhren  
  Stmt.Execute()
  Stmt = $NULL
   
ENDE SOLANGE

DataBase.Commit()

TEXTGEN !Meldung; "Punkte in Excel-Datei # ausgegeben"; !TabName
MELDUNG NEUTRAL; !Meldung